//
//  NEXLockStatus.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NELockStatus.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents whether the device is locked or unlocked.
 */
@interface NEXLockStatus : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param lockStatus NELockStatus to copy from.
 */
- (instancetype)initWithLockStatus:(NELockStatus)lockStatus;

/**
 * Conversion copy constructor.
 * @param lockStatus NELockStatus to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithLockStatus:(NELockStatus)lockStatus confidence:(double)confidence;

/**
 * @param state State to assume.
 */
- (instancetype)initWithState:(NELockStatusState)state;

/**
 * @param state State to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NELockStatusState)state confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NELockStatus value DEPRECATED_ATTRIBUTE;

/**
 * Whether the device is locked or unlocked.
 */
@property(nonatomic, readwrite) NELockStatusState state;

+ (NSString*)stringFromState:(NELockStatusState)state;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NELockStatus_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NELockStatus)c_val;

@end
NS_ASSUME_NONNULL_END
